import java.util.function.*;
import java.util.*;

public class LambdaDemo{

  public static<T> boolean allTrue(List<T> a, Predicate<T> pred){
    for (T x : a){
      if(x!=null && !pred.test(x))
        return false;
    }
    return true;
  }



  public static void main(String[] args) {
    Predicate<Integer> isEven = x -> x%2==0;
    Predicate<Integer> isOdd = x -> x%2!=0;

    System.out.println("Is 5 even? " + isEven.test(5));    // Test isEven on value 5.
    System.out.println("Is 4 even? " + isEven.test(4));      // Test on value 5.

    System.out.println("Is 5 odd? " + isOdd.test(5));      // Test isEven on value 5.
    System.out.println("Is 4 odd? " + isOdd.test(4));      // Test on value 5.


    // using default methods OR and AND
    Predicate<Integer> alwaysTrue = isEven.or(isOdd);
    Predicate<Integer> alwaysFalse = isEven.and(isOdd);


    System.out.println("Always true 4? " + alwaysTrue.test(4));
    System.out.println("Always false 4? " + alwaysFalse.test(4));

     List<Integer> a = new LinkedList<Integer>();
    a.add(2); a.add(4); a.add(6);
    System.out.println("All even [2,4,6]? " + allTrue(a, isEven));


  }
}
